function bspline_aufg
% Aufgabe 3
tau=[0 1 2 4 5 6];
bkoeffs(tau,0.5,3)

subplot(2,4,1);
tt=linspace(0,6,1000)';
B=bkoeffs(tau,tt,3);
plot(tt,B(:,1:3,3));
axis([min(tt)-1 max(tt)+1 -0.5 1.2]);
title('Aufgabe 3a B_{-2,3}...B_{0,3}');
subplot(2,4,2);
plot(tt,B(:,1:4,2));
axis([min(tt)-1 max(tt)+1 -0.5 1.2]);
title('Aufgabe 3a B_{-2,2}...B_{1,2}');

% Aufgabe 4
k=4;l=12;

t=-3:16;
offt=4;

tt=linspace(min(t),max(t),10*length(t))';
B=bkoeffs(t,tt,k);

subplot(2,2,2);
plot(tt,B(:,(4:6)+offt,k));
axis([4 10 -0.5 1.2]);
title('Aufgabe 4a');

subplot(2,2,3);
s4=zeros(size(tt));
for i=1:13
    s4=s4+sin((i-1)*pi/4)*B(:,i-1+offt,k);
end;
plot(tt,s4);
title('Aufgabe 4b');

subplot(2,2,4);
tt=linspace(4,10,25)';
B=bkoeffs(t,tt,k);
s=zeros(length(tt),length(tt));
for i=1:length(tt);
    s(:,i)=B(:,4+offt,k)*B(i,6+offt,k);
end;
mesh(tt,tt,s,'EdgeColor','k');
colormap([0 0 0]);
axis([min(tt) max(tt) min(tt) max(tt) 0 1]);
shading faceted
title('Aufgabe 4c');



function B=bkoeffs(tau,tt,k)
for i=1:length(tau)-1
    B(:,i,1)=1*((tt>=tau(i)) & (tt<tau(i+1)));
end;
for r=2:k
    for i=1:length(tau)-r
        B(:,i,r)=0;
        if tau(i+r-1)>tau(i)
            B(:,i,r)=B(:,i,r)+(tt-tau(i))./(tau(i+r-1)-tau(i)).*B(:,i,r-1);
        end;
        if tau(i+r)>tau(i+1)
            B(:,i,r)=B(:,i,r)+(tau(i+r)-tt)./(tau(i+r)-tau(i+1)).*B(:,i+1,r-1);
        end;
    end;
end;